=== contrib/gtest/CMakeLists.txt ===
ADD_LIBRARY (gtest-lib STATIC
    gtest-all.cc
)
