=== debian/changelog ===
proxysql2 (2.0.12) unstable; urgency=medium

  * Update to new upstream release Proxysql 2.0.12-1.1

 -- debian-cloud-user <jenkins@minimal-jessie-x64-3523>  Fri, 05 Jun 2020 06:31:43 +0000

proxysql2 (2.0.12) unstable; urgency=low

  * Initial Release.

 -- EvgeniyPatlan <evgeniy.patlan@percona.com>  thu, 14 Jul 2016 07:41:56 -0400
