=== contrib/ls-config/debian/control ===
Source: ls-config
Section: main
Priority: standard
Maintainer: Łukasz A. Grabowski <www@lucas.net.pl>
Build-Depends: debhelper (>= 8.0.0), libconfig9
Standards-Version: 3.9.3
Homepage: http://www.lucas.net.pl
Vcs-Git: https://github.com/lucas-net-pl/ls-config.git
Vcs-Browser: https://github.com/lucas-net-pl/ls-config

Package: ls-config
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Simple program allo use libconfig style conf in bash
 This software allo to use libconfig9 style configuration files
 in bash scripts by invoke this soft. It contain bash library too,
 witch easying this job.
